// XDSPView.cpp : implementation of the CXDSPView class
//

#include "stdafx.h"
#include "XDSP.h"

#include "XDSPDoc.h"
#include "XDSPView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CXDSPView

IMPLEMENT_DYNCREATE(CXDSPView, CFormView)

BEGIN_MESSAGE_MAP(CXDSPView, CFormView)
	//{{AFX_MSG_MAP(CXDSPView)
	ON_EN_CHANGE(IDC_EDIT1, OnChangeEdit1)
	ON_BN_CLICKED(IDC_Read, OnRead)
	ON_BN_CLICKED(IDC_Write, OnWrite)
	ON_BN_CLICKED(IDC_Clear, OnClear)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXDSPView construction/destruction

CXDSPView::CXDSPView()
	: CFormView(CXDSPView::IDD)
{
	//{{AFX_DATA_INIT(CXDSPView)
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	success=true;
	if (ConnectToDriver())
	{
		if (!IsDrvPresent())
		{
			success=false;
			AfxMessageBox("Necessary driver isn't present in the system",MB_ICONERROR | MB_OK);
		}
	}
		else 
		success=false;
}

CXDSPView::~CXDSPView()
{
}

void CXDSPView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CXDSPView)
	DDX_Control(pDX, IDC_Size, m_size);
	DDX_Control(pDX, IDC_Write, m_write);
	DDX_Control(pDX, IDC_Read, m_read);
	DDX_Control(pDX, IDC_Clear, m_clear);
	DDX_Control(pDX, IDC_EDIT1, m_buff);
	//}}AFX_DATA_MAP
}

BOOL CXDSPView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CXDSPView::OnInitialUpdate()
{
	char len[10];
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

	if (!success)
	{
		m_read.EnableWindow(false);
		m_clear.EnableWindow(false);
		m_write.EnableWindow(false);
		m_buff.EnableWindow(false);

	}
	else
	{
		itoa(GetTotalLen(),len,10);	
		m_size.SetWindowText(len);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CXDSPView diagnostics

#ifdef _DEBUG
void CXDSPView::AssertValid() const
{
	CFormView::AssertValid();
}

void CXDSPView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CXDSPDoc* CXDSPView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CXDSPDoc)));
	return (CXDSPDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CXDSPView message handlers

void CXDSPView::OnChangeEdit1() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	CXDSPDoc *m_doc;
	m_doc=GetDocument();

	m_buff.GetWindowText((char*)m_doc->m_buffer,32767);
	// TODO: Add your control notification handler code here
	
}

bool CXDSPView::ConnectToDriver()
{
	success=true;
	InterDll=::LoadLibrary("XDSPInter");
	if (InterDll==NULL)
	{
		AfxMessageBox("Couldn't load a library XDSPInter.dll",MB_ICONERROR | MB_OK);
		success=false;
	}
	else
	{
		ReadMem=(MemReadFun)::GetProcAddress(InterDll,"ReadMem");
		if (ReadMem==NULL)
		{
			AfxMessageBox("Couldn't get an adress for ReadMem function from library XDSPInter.dll",MB_ICONERROR | MB_OK);
			success=false;
		}
		WriteMem=(MemReadFun)::GetProcAddress(InterDll,"WriteMem");
		if (WriteMem==NULL)
		{
			AfxMessageBox("Couldn't get an adress for WriteMem function from library XDSPInter.dll",MB_ICONERROR | MB_OK);
			success=false;
		}
		GetMemSize=(MemSizeFun)::GetProcAddress(InterDll,"GetMemSize");
		if (GetMemSize==NULL)
		{
			AfxMessageBox("Couldn't get an adress for GetMemSize function from library XDSPInter.dll",MB_ICONERROR | MB_OK);
			success=false;
		}
		IsDriverPresent=(IsDrivFun)::GetProcAddress(InterDll,"IsDriverPresent");
		if (GetMemSize==NULL)
		{
			AfxMessageBox("Couldn't get an adress for IsDriverPresent function from library XDSPInter.dll",MB_ICONERROR | MB_OK);
			success=false;
		}

	}
	return(success);
}

void CXDSPView::OnRead() 
{
	int res;
	res=(*ReadMem)(dt,256);
	m_buff.SetWindowText(dt);

	CXDSPDoc *m_doc;
	m_doc=GetDocument();
	strcpy((char*)m_doc->m_buffer,dt);
}

void CXDSPView::OnWrite() 
{
	m_buff.GetWindowText(dt,32767);
	int res;
	res=(*WriteMem)(dt,strlen(dt));
	
}

void CXDSPView::OnClear() 
{
	CXDSPDoc *m_doc;
	m_doc=GetDocument();
	for	(int i=0;i<1025;i++)
		dt[i]=0;
	m_doc->m_buffer[0]=0;
	int res;
	res=(*WriteMem)(dt,256);
	m_buff.SetWindowText(dt);
}

int CXDSPView::GetTotalLen()
{
	int res=(*GetMemSize)();
	return(res);
}

bool CXDSPView::IsDrvPresent()
{
	return((*IsDriverPresent)());
}
