// XDSPView.h : interface of the CXDSPView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_XDSPVIEW_H__2C557BDA_BED2_44F3_8740_40FC8C9324C8__INCLUDED_)
#define AFX_XDSPVIEW_H__2C557BDA_BED2_44F3_8740_40FC8C9324C8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define XDSPINTER_API __declspec(dllimport)
typedef XDSPINTER_API int ( *MemReadFun)(char *data, int len);
typedef XDSPINTER_API int ( *MemWrtFun)(char *data, int len);
typedef XDSPINTER_API int ( *MemSizeFun)();
typedef XDSPINTER_API bool ( *IsDrivFun)();

class CXDSPView : public CFormView
{
protected: // create from serialization only
	char dt[32768];
	CXDSPView();
	DECLARE_DYNCREATE(CXDSPView);
	MemReadFun ReadMem;
	MemWrtFun WriteMem;
	MemSizeFun GetMemSize;
	IsDrivFun IsDriverPresent;
public:
	//{{AFX_DATA(CXDSPView)
	enum { IDD = IDD_XDSP_FORM };
	CEdit	m_size;
	CButton	m_write;
	CButton	m_read;
	CButton	m_clear;
	CEdit	m_buff;
	//}}AFX_DATA

// Attributes
public:
	CXDSPDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CXDSPView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	//}}AFX_VIRTUAL

// Implementation
public:
	bool IsDrvPresent();
	int GetTotalLen();
	bool success;
	HINSTANCE InterDll;
	bool ConnectToDriver();
	virtual ~CXDSPView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CXDSPView)
	afx_msg void OnChangeEdit1();
	afx_msg void OnRead();
	afx_msg void OnWrite();
	afx_msg void OnClear();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in XDSPView.cpp
inline CXDSPDoc* CXDSPView::GetDocument()
   { return (CXDSPDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_XDSPVIEW_H__2C557BDA_BED2_44F3_8740_40FC8C9324C8__INCLUDED_)
