// XDSPInter.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "XDSPInter.h"
//#include "XDSPdrvioctl.h"

#define XDSPDRV_IOCTL_GETMEMSIZE	0x800
// Handle to device opened in driver.
//
HANDLE	hDevice = INVALID_HANDLE_VALUE;

// Name used to open device
//
char *sLinkName = "\\\\.\\XDSPdrvDevice0";
UINT dwSize;

HANDLE OpenByName(void)
{
	// Create a handle to the driver
	return CreateFile(sLinkName,
					  GENERIC_READ | GENERIC_WRITE,
					  FILE_SHARE_READ,
					  NULL,
					  OPEN_EXISTING,
					  0,
					  NULL);
}


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			{
				break;
			}
		case DLL_THREAD_ATTACH:
			{				
				break;
			}
		case DLL_THREAD_DETACH:
			{
				if (hDevice != INVALID_HANDLE_VALUE)
					CloseHandle(hDevice);
				hDevice = INVALID_HANDLE_VALUE;
				break;
			}
		case DLL_PROCESS_DETACH:
			{
				if (hDevice != INVALID_HANDLE_VALUE)
					CloseHandle(hDevice);
				hDevice = INVALID_HANDLE_VALUE;
				break;
			}
    }
    return TRUE;
}

EXPORT bool IsDriverPresent(void)
{
	hDevice=OpenByName();
	if (hDevice == INVALID_HANDLE_VALUE)
		return(false);
	else
		return(true);


};

EXPORT int ReadMem(char *data, int len)
{
	unsigned long rd=0;
	//::MessageBox(0,"ReadMem","XDSPInter.dll",MB_OK);
	
	len%=4;//words
	ReadFile(hDevice, data, len, &rd, NULL);
	//len - requested 
	//rd - read
	data[len*4+1]=0;
	return(rd);

}

EXPORT int WriteMem(char *data, int len)
{
	unsigned long nWritten=0;
	//::MessageBox(0,"WriteMem","XDSPInter.dll",MB_OK);
	len%=4;//words
	WriteFile(hDevice, data, len, &nWritten, NULL);
	//len - requested
	//nWritten - read
	return nWritten;
}

EXPORT int GetMemSize(void)
{
//	unsigned int* pBufOutput;
	CHAR	bufInput[4];		// Input to device
	unsigned long bufOutput;

//	pBufOutput=&bufOutput;
	ULONG	nOutput;			// Count written to bufOutput

	// Call device IO Control interface (XDSPDRV_IOCTL_GETMEMSIZE) in driver
	if (!DeviceIoControl(hDevice,
						 XDSPDRV_IOCTL_GETMEMSIZE,
						 bufInput,
						 4,
						 &bufOutput,
						 4,
						 &nOutput,
						 NULL)
	   )
	   return(0);
	else
		return(bufOutput);

}